<!DOCTYPE HTML>
<html lang="en-US">
<head>
	<link rel="apple-touch-icon-precomposed" sizes="180x180" href="static/images/favicon-default.png">
	<link rel="icon" sizes="192x192" href="static/images/favicon-default.png">
	<link rel="alternate" type="application/rss+xml" title="Matt Bryant - Articles" href="https://programsareproofs.com/rss.xml">

	<link rel="stylesheet" href="static/css/main.css" type="text/css"/>
	<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1, user-scalable=0"/>
	<meta name="referrer" content="no-referrer"/>
	<meta name="Description" content="About Matt Bryant">

	<!-- Facebook OpenGraph -->
	<meta property="og:description" content="Matt Bryant"/>
	<meta property="og:image"       content="static/images/favicon-default.png"/>

	<title>Matt Bryant</title>
</head>
<body>
<canvas class="hills" id="hills-background"></canvas>
<canvas class="hills" id="hills-canvas4"></canvas>
<canvas class="hills" id="hills-canvas3"></canvas>
<canvas class="hills" id="hills-canvas2"></canvas>
<canvas class="hills" id="hills-canvas1"></canvas>
<div id="main">
	<h1>Matt Bryant</h1>
	<h2>About Me</h2>
    <p>
    I currently work in San Francisco at <b>Asana</b>, and during my free time I enjoy climbing, photography, <a href="https://recipes.programsareproofs.com" target="_blank">cooking</a>, working on random projects, and playing DotA.
		I like writing code and solving tricky problems, especially related to optimization or security.
		I run OpenSUSE on my computers, and am a strong supporter of the FOSS movement.
		<br><br>
		I occasionally write about things <a href="blog.html" target="_blank">elsewhere on my site</a>.
		<br><br>
		I can be reached by email at <span class="email">mbryant<span class=at></span>programsareproofs.com</span> (<a href="pgp.html">PGP key</a>), and you may be interested in my <a href="https://box.programsareproofs.com/files/Resume.pdf">official resume</a>.
	</p>

	<h2>Current Projects</h2>
    <p>
		I recently built <a href="https://functiontrace.com" target="_blank">FunctionTrace</a>, a better Python profiler.  It's a non-sampled profiler with an intuitive graphical interface that is able to profile multiprocess and multithreaded applications, all while having an order-of-magnitude lower overhead than other Python profilers.
	</p>

	<h2>Languages</h2>
    <p>
		I am most excited by <b>Rust</b>, which I think has the potential to be the systems language of the future.
		Until then, I tend to use <b>C</b>, <b>Python</b>, and <b>Javascript</b>, all of which I have had close to a decade of professional experience with.
		<br><br>
		I have also worked for hundreds of hours with each of <b>x86 Assembly</b>, <b>JavaScript</b>, <b>C++</b>, <b>Ocaml</b>, <b>Java</b>, <b>Standard ML</b>, <b>PHP</b>, and <b>Bash</b>, and have some experience with <b>Haskell</b>, <b>ARM Assembly</b>, <b>PPC Assembly</b>, and various <b>DBMS</b>.
	</p>

	<h2>Experience</h2>
    <p>
		<b>Infrastructure Security Tech/Program Lead</b> at <b><a href="https://asana.com" rel="noreferrer" target="_blank">Asana</a></b> from <b>January 2019</b> to <b>Present</b><br>
		I'm responsible for infrastructure security at Asana, with my focus being preventing malicious actors from being able to access customer data.  <!--I've led various projects providing stronger infrastructure compartmentalization, such as building better authentication to production servers, isolating privileged or untrusted services via AWS Lambda, and designing a novel approach for end-to-end encryption that still supports search. -->
		<br><br>

		<b>Software Development Engineer</b> at <b><a href="http://www.ghs.com" rel="noreferrer" target="_blank">Green Hills Software</a></b> from <b>July 2016</b> to <b>January 2019</b><br>
		I worked on safety and performance critical code used in embedded systems around the world, including rockets, planes, and millions of cars, and was the lead developer on a major project to build secure computers for remote work.<br>
		Among other things, I built a mutex that doesn't suffer from contention, developed a secure GPU virtualization approach, and designed more secure systems using virtualization and isolation.
		<br><br>

		<b>B.S. in Computer Science</b> from <b>Carnegie Mellon University</b> in <b>2016</b><br>
		I studied Computer Science and minored in Mathematics at CMU.
		<br><br>

		<b>Teaching Assistant</b> at <b>Carnegie Mellon</b> from <b>August 2013</b> to <b>May 2016</b><br>
		I was a teaching assistant for five courses over six semesters at Carnegie Mellon:
		15-410 (<i>Operating System Design and Implementation</i>), 15-411 (<i>Compiler Design</i>), 15-210 (<i>Parallel and Sequential Data Structures and Algorithms</i>), 15-213 (<i>Introduction to Computer Systems</i>), and 15-122 (<i>Principles of Imperative Programming</i>).
		I interacted with hundreds of students while designing homeworks and projects, holding office hours, teaching recitations, and grading assignments.
		<br><br>

		<b>Security Research Internship</b> at <b><a href="http://www.baesystems.com/home?r=ai" rel="noreferrer" target="_blank">BAE Systems Applied Intelligence</a></b> from <b>June 2015</b> to <b>August 2015</b><br>
		I did research on efficient and non-invasive taint analysis for common off-the-shelf programs, including developing a programmatic debugger for <tt>x86_64</tt>.
		Additionally, I developed several scalable lock-free data structures, and contributed to a lock-free Python interpreter.
		<br><br>

		<b>Security Internship</b> at <b><a href="http://www.silversky.com" rel="noreferrer" target="_blank">SilverSky</a></b> from <b>June 2014</b> to <b>August 2014</b><br>
		I worked on a project to defend Microsoft Word against file-based exploits through server-side monitoring.
		My research culminated with the creation of a novel framework that was able to successfully detect and prevent numerous zero-day exploits against common programs, including Internet Explorer, Microsoft Word, and Adobe Reader.
		<br><br>

		<b>Software Engineer Internship</b> at <b><a href="http://www.silversky.com" rel="noreferrer" target="_blank">SilverSky</a></b> from <b>June 2013</b> to <b> August 2013</b><br>
		I developed a custom functional/regression testing tool for one of SilverSky's flagship email management products, allowing them to move faster and ensure product stability.
		<br><br>

		<b>Software Engineer Internship</b> at <b><a href="" rel="noreferrer" target="_blank">Perimeter E-Security</a></b> from <b>June 2011</b> to <b> August 2012</b><br>
		I developed the mobile version of Perimeter’s flagship email client from scratch, supporting hundreds of enterprise customers.  Additionally, I made various changes to the mail server and client, including adding support for POP3 over SSL and improving calendar usability.
		<br><br>

		<b>Eagle Scout</b> as of <b>June 2011</b><br>
		For my Eagle Scout project, I planned and managed the renovation of the cross-country running trails behind Monmouth Academy.
		With the help of dozens of volunteers, I turned more than half a mile of perpetual swamp into well-drained running trails where races are still held.
	</p>
	<h2></h2>
</div>
</body>
<script src="static/js/mountains.js"></script>
<script>
	let canvases = Array(MountainConfig.maxLevel).fill().map((_,i) => document.getElementById("hills-canvas" + (i + 1)));
	new MountainScreen(canvases).render();
</script>
</html>
